//======================================
//FileName	=	USB.c
//======================================

#include "Ai8051U.h"
#include "usb.h"
#include "usb_req_std.h"
#include "usb_req_class.h"
#include "usb_req_vendor.h"
#include "util.h"
#include "config.h"

//USB ȫֱ
BYTE DeviceState;						//豸״̬
SETUP Setup;							//ýṹ
EPSTATE Ep0State;						//˵0Ľṹ
BYTE InEpState;							//˵״̬(0=IDEL, 1=STALL)	[bit5:1 αʾIN˵ 0x85 ~ 0x81 ״̬, bit7=bit6=bit0=0]
BYTE OutEpState;						//˵״̬(0=IDEL, 1=STALL)	[bit5:1 αʾOUT˵ 0x05 ~ 0x01 ״̬, bit7=bit6=bit0=0]
BYTE xdata UsbBuffer[256];				//USB

//--------------------------------------
//USBӿڵĳʼ
//--------------------------------------
void usb_init(void)
{
    P3M0 &= ~0x03;
    P3M1 |= 0x03;						//P30/P31 ģʽ

    IRC48MCR = 0x80;					//ʹƬIRC48MHzʱ
    while (!(IRC48MCR & 0x01));			//ȴbit0=1 ʾIRC 48MHzʱȶ

										//IRCBAND ϵĬֵ USBCKS =1, USBCKS2=0 USBʱʹIRC48MHzרʱ!! 
    USBCLK = 0x00;						//ֹPLLƵ,PCKI=PLL/1,ֹʱ׷Ƶ,ֹUSBģʽ,ֹPHYģʽ,
    USBCON = 0x90;						//USBʱʹ,USB˿1.5Kʹ; [֪ͨ,USB豸]

    usb_write_reg(FADDR, 0x00);			//ַܵ=0x00
    usb_write_reg(POWER, 0x09);			//ʼ߸λ,ʹ߹ʽ
    usb_write_reg(INTRIN1E, 0x3f);		//ʹEP1~5INж,ʹEP0IN/OUTж
    usb_write_reg(INTROUT1E, 0x3f);		//ʹEP1~5OUTж,bit0Ч
    usb_write_reg(INTRUSBE, 0x07);		//ֹUSB֡ʼźж,USB λ/ָ/ źж
    usb_write_reg(POWER, 0x01);			//ֹͣ߸λ,ʹ߹ʽ

    DeviceState = DEVSTATE_DEFAULT;		//豸״̬ = Ĭֵ
    Ep0State.bState = EPSTATE_IDLE;		//EP0״̬ = 
    InEpState = 0x00;					//˵ IN ״̬ = 0
    OutEpState = 0x00;					//˵ OUT ״̬ = 0

    IE2 |= EUSB;						//USBжʹ
}

//--------------------------------------
//ַָaddrļӼĴ
//--------------------------------------
BYTE usb_read_reg(BYTE addr)
{
	BYTE dat;

	while (USBADR & 0x80);				//ȴUSBDATеЧ()
	USBADR = addr | 0x80;				//ӼĴ,ַaddr
	while (USBADR & 0x80);				//ȴUSBDATеЧ
	dat = USBDAT;						//

	return dat;
}

//--------------------------------------
//ַΪaddrļӼĴдֽdat
//--------------------------------------
void usb_write_reg(BYTE addr, BYTE dat)
{
	while (USBADR & 0x80);				//BUSY=1 USBĴæ
	USBADR = addr & 0x7f;				//дַĴ
	USBDAT = dat;						//ֽдĴ
}

//--------------------------------------
//ָ fifo еݴ,سֵ,ݴ*pdat
//--------------------------------------
BYTE usb_read_fifo(BYTE fifo, BYTE *pdat)
{
    BYTE cnt;
    BYTE ret;

    ret = cnt = usb_read_reg(COUNT0);	//õEP0OUTݵĳȡCOUNT0 ĵַ  OUTCOUNT1 ĵַ غϵ!
    while (cnt--)
    {
    	*pdat++ = usb_read_reg(fifo);	//ָ fifo һֽ
    }

    return ret;
}

//--------------------------------------
//FIFOдָcntȵݴ*pdat
//--------------------------------------
void usb_write_fifo(BYTE fifo, BYTE *pdat, BYTE cnt)
{
	while (cnt--)
	{
        usb_write_reg(fifo, *pdat++);
    }
}

//--------------------------------------
//USBжϺ
//--------------------------------------
void usb_isr(void) interrupt USB_VECTOR
{
BYTE intrusb;							//֡ʼ,λ,ָ, źŵжϱ־
BYTE intrin;							//EP5~EP1 INжϱ־λ  EP0IN/OUTжϱ־λ
BYTE introut;							//EP5~EP1 OUTжϱ־λ
BYTE adrTemp;							//еǰ USBADR еֵ 

    adrTemp = USBADR;					//USBADR ֳ,ѭдUSBADRж,ж޸USBADR

    intrusb = usb_read_reg(INTRUSB);	//ȡ ֡ʼ,λ,ָ, źŵжϱ־, ȡ֮ӲԶ˼Ĵжϱ־λ
    intrin = usb_read_reg(INTRIN1);		//ȡ EP5~EP1 INжϱ־λ  EP0IN/OUTжϱ־λ, ȡ֮ӲԶ
    introut = usb_read_reg(INTROUT1);	//ȡ EP5~EP1 OUTжϱ־λ, ȡ֮ӲԶ

    if(intrusb & RSUIF) usb_resume();	// ָ
    if(intrusb & RSTIF) usb_reset();	// λ

    if(intrin & EP0IF) usb_setup();		//EP0IN/OUTж,ƶ˵ ò

//˵1~5IN(ݷ)жϲ	
#ifdef EN_EP1IN
    if(intrin & EP1INIF) usb_in_ep1();
#endif
#ifdef EN_EP2IN
    if(intrin & EP2INIF) usb_in_ep2();
#endif
#ifdef EN_EP3IN
    if(intrin & EP3INIF) usb_in_ep3();
#endif
#ifdef EN_EP4IN
    if(intrin & EP4INIF) usb_in_ep4();
#endif
#ifdef EN_EP5IN
    if(intrin & EP5INIF) usb_in_ep5();
#endif

//˵1~5OUT(ݽ)жϲ	
#ifdef EN_EP1OUT
    if(introut & EP1OUTIF) usb_out_ep1();	//ܲ,յԭ
#endif
#ifdef EN_EP2OUT
    if(introut & EP2OUTIF) usb_out_ep2();
#endif
#ifdef EN_EP3OUT
    if(introut & EP3OUTIF) usb_out_ep3();
#endif
#ifdef EN_EP4OUT
    if(introut & EP4OUTIF) usb_out_ep4();
#endif
#ifdef EN_EP5OUT
    if(introut & EP5OUTIF) usb_out_ep5();
#endif

    if(intrusb & SUSIF) usb_suspend();	// 

    USBADR = adrTemp;					//USBADR ֳָ
}


//--------------------------------------
//USBͷź
//--------------------------------------
void usb_resume(void)
{
}


//======================================
//USBλ
//======================================
void usb_reset(void)
{
	usb_write_reg(FADDR, 0x00);			//ֵַܵ =0
	DeviceState = DEVSTATE_DEFAULT;		//豸״̬ = Ĭ
	Ep0State.bState = EPSTATE_IDLE;		//ƶ˵(EP0)״̬ =

#ifdef EN_EP1IN
    usb_write_reg(INDEX, 1);			//ѡEP1
    usb_write_reg(INCSR1, INCLRDT | INFLUSH);	//IN˵ лλ λ"0", FIFO
#endif
#ifdef EN_EP2IN
    usb_write_reg(INDEX, 2);			//ѡEP2
    usb_write_reg(INCSR1, INCLRDT | INFLUSH);	//IN˵ лλ λ"0", FIFO
#endif
#ifdef EN_EP3IN
    usb_write_reg(INDEX, 3);			//ѡEP3
    usb_write_reg(INCSR1, INCLRDT | INFLUSH);	//IN˵ лλ λ"0", FIFO
#endif
#ifdef EN_EP4IN
    usb_write_reg(INDEX, 4);			//ѡEP4
    usb_write_reg(INCSR1, INCLRDT | INFLUSH);	//IN˵ лλ λ"0", FIFO
#endif
#ifdef EN_EP5IN
    usb_write_reg(INDEX, 5);			//ѡEP5
    usb_write_reg(INCSR1, INCLRDT | INFLUSH);	//IN˵ лλ λ"0", FIFO
#endif

#ifdef EN_EP1OUT
    usb_write_reg(INDEX, 1);			//ѡEP1
    usb_write_reg(OUTCSR1, OUTCLRDT | OUTFLUSH);//OUT˵ лλ λ"0", FIFO
#endif
#ifdef EN_EP2OUT
    usb_write_reg(INDEX, 2);			//ѡEP2
    usb_write_reg(OUTCSR1, OUTCLRDT | OUTFLUSH);//OUT˵ лλ λ"0", FIFO
#endif
#ifdef EN_EP3OUT
    usb_write_reg(INDEX, 3);			//ѡEP3
    usb_write_reg(OUTCSR1, OUTCLRDT | OUTFLUSH);//OUT˵ лλ λ"0", FIFO
#endif
#ifdef EN_EP4OUT
    usb_write_reg(INDEX, 4);			//ѡEP4
    usb_write_reg(OUTCSR1, OUTCLRDT | OUTFLUSH);//OUT˵ лλ λ"0", FIFO
#endif
#ifdef EN_EP5OUT
    usb_write_reg(INDEX, 5);			//ѡEP5
    usb_write_reg(OUTCSR1, OUTCLRDT | OUTFLUSH);//OUT˵ лλ λ"0", FIFO
#endif

    usb_write_reg(INDEX, 0);			//ѡ˵0
}

//--------------------------------------
//USB
//--------------------------------------
void usb_suspend(void)
{
}

//--------------------------------------
//EP0IN/OUTж,ƶ˵ ò
//--------------------------------------
void usb_setup(void)
{
BYTE csr;

	usb_write_reg(INDEX, 0);			//ѡ˵0
	csr = usb_read_reg(CSR0);			//˵0Ŀ״̬

	if(csr & STSTL)
	{									//STALL źŷ
		usb_write_reg(CSR0, csr & ~STSTL);	//Լд 0 ־λ
		Ep0State.bState = EPSTATE_IDLE;	//EP0Ķ˵״̬ =
	}

	if(csr & SUEND)
	{									//SETUP 
		usb_write_reg(CSR0, csr | SSUEND);  // SSUEND д 1  SUEND ־λ
	}

	switch(Ep0State.bState)
	{									//EP0 ״̬
	case EPSTATE_IDLE:					//״̬
		if(csr & OPRDY)
		{								//յһ OUT ݰ
			usb_read_fifo(FIFO0, (BYTE *)&Setup);		//EP0˵OUTݰ,ݽṹSETUP
			Setup.wLength = reverse2(Setup.wLength);	//õEP0˵OUTݰ  ݳֵ
			
			switch (Setup.bmRequestType & REQUEST_MASK)
			{											//ж bmRequestType.bit5&4
			case STANDARD_REQUEST:
				usb_req_std();			//׼ Ĵ
				break;

			case CLASS_REQUEST:
				usb_req_class();		// Ĵ
				break;
            
			case VENDOR_REQUEST:
				usb_req_vendor();		// Ĵ
				break;
            
			default:					//ǰ3,쳣
				usb_setup_stall();		//ֹͣ˵
				return;
			}
		}
		break;

	case EPSTATE_DATAIN:				//״̬
		usb_ctrl_in();					//EP0INݰ
		break;
	
	case EPSTATE_DATAOUT:				//״̬
		usb_ctrl_out();					//EP0OUTݰ
		break;
	}
}

//--------------------------------------
//ö˵0 = STALL 쳣
//CSR0.SOPRDY =1  OPRDY(Out Packet Ready) ־,˵OUTĴ
//CSR0.SDSTL =1 յ  ֵ֧,  STALL ź,ӲԶ
//--------------------------------------
void usb_setup_stall(void)
{
	Ep0State.bState = EPSTATE_STALL;
	usb_write_reg(CSR0, SOPRDY | SDSTL);	
}

//--------------------------------------
//ö˵0 = DATAIN
//CSR0.SOPRDY =1  OPRDY(Out Packet Ready) ־,˵OUTĴ
//--------------------------------------
void usb_setup_in(void)
{
	Ep0State.bState = EPSTATE_DATAIN;
	usb_write_reg(CSR0, SOPRDY);
	usb_ctrl_in();
}

//--------------------------------------
//ö˵0 = DATAOUT
//CSR0.SOPRDY =1  OPRDY(Out Packet Ready) ־,˵OUTĴ
//--------------------------------------
void usb_setup_out(void)
{
	Ep0State.bState = EPSTATE_DATAOUT;
	usb_write_reg(CSR0, SOPRDY);
}

//--------------------------------------
//ö˵ = IDEL
//CSR0.SOPRDY =1  OPRDY(Out Packet Ready) ־,˵OUTĴ
//CSR0.DATEND =1 һݰ, SOPRDY=1
//--------------------------------------
void usb_setup_status(void)
{
	Ep0State.bState = EPSTATE_IDLE;
	usb_write_reg(CSR0, SOPRDY | DATEND);
}

//--------------------------------------
//Ϳƶ˵(EP0)INݰ
// Ep0State
//--------------------------------------
void usb_ctrl_in(void)
{
BYTE csr;
BYTE cnt;

	usb_write_reg(INDEX, 0);			//ָEP0,ܶȡCSR0
	csr = usb_read_reg(CSR0);			//ȡCSR0
	if(csr & IPRDY) return;				//ǰ IN ĵȴ,˳

	cnt = Ep0State.wSize > EP0_SIZE ? EP0_SIZE : Ep0State.wSize;	//cntΪ EP0_SIZE
	usb_write_fifo(FIFO0, Ep0State.pData, cnt);	//Ҫ͵дEP0ݻ FIFO0
	Ep0State.wSize -= cnt;				//ͳ -cnt
	Ep0State.pData += cnt;				//ָ +cnt
	
	if (Ep0State.wSize == 0)
	{									//ݷ
		usb_write_reg(CSR0, IPRDY | DATEND);	//ݾ || дһݰ
		Ep0State.bState = EPSTATE_IDLE;	//˵״̬ =IDEL
    }
    else
	{									//кķ
        usb_write_reg(CSR0, IPRDY);		//ݾ
    }
}

//--------------------------------------
//տƶ˵(EP0)OUTݰ
// Ep0State
//--------------------------------------
void usb_ctrl_out(void)
{
BYTE csr;
BYTE cnt;

	usb_write_reg(INDEX, 0);			//ָEP0,ܶȡCSR0
	csr = usb_read_reg(CSR0);			//ȡCSR0
	if(!(csr & OPRDY)) return;			//ǰûOUT,˳

	cnt = usb_read_fifo(FIFO0, Ep0State.pData);	//OUT,cnt
	Ep0State.wSize -= cnt;				//ճ -cnt
	Ep0State.pData += cnt;				//ָ +cnt

	if(Ep0State.wSize == 0)
	{									//ݽ
		usb_write_reg(CSR0, SOPRDY | DATEND);	//ݴ || Լһݰ
		Ep0State.bState = EPSTATE_IDLE;	//˵״̬ =IDEL
	}
	else
	{									//кĽ
		usb_write_reg(CSR0, SOPRDY);	//ݴ
	}
}

//--------------------------------------
//˵ݴ, INݷ
//:
//	pData	ݵָ
//	bSize	ݵĳ
//	ep		ָ˵(1~5)
//:	
//--------------------------------------
void usb_bulk_intr_in(BYTE *pData, BYTE bSize, BYTE ep)
{
	usb_write_fifo((BYTE)(FIFO0 + ep),pData,bSize);	//дָ˵FIFO1~FIFO5
	usb_write_reg(INCSR1, INIPRDY);					//IN׼־
}

//--------------------------------------
//˵ݴ, OUTݽ
//:
//	pData	ݵָ
//	ep		ָ˵(1~5)
//:	ݵĳ
//--------------------------------------
BYTE usb_bulk_intr_out(BYTE *pData, BYTE ep)
{
BYTE cnt;

	cnt = usb_read_fifo((BYTE)(FIFO0 + ep), pData);	//ָ˵FIFO1~FIFO5
	usb_write_reg(OUTCSR1, 0);						//OUT״̬Ĵ

	return cnt;
}

#ifdef EN_EP1IN
void usb_in_ep1(void)
{
BYTE csr;

	usb_write_reg(INDEX, 1);			//ѡ EP1
	csr = usb_read_reg(INCSR1);			// IN ״̬
	if(csr & INSTSTL)
	{									//STALL źŷ
		usb_write_reg(INCSR1, INCLRDT);	//лλ λ"0"
	}
	
	if(csr & INUNDRUN)					//ݲ־ =1
	{
		usb_write_reg(INCSR1, 0);		//IN״̬Ĵ
	}
}
#endif

#ifdef EN_EP2IN
void usb_in_ep2(void)
{
BYTE csr;
	
	usb_write_reg(INDEX, 2);			//ѡ EP2              
	csr = usb_read_reg(INCSR1);         // IN ״̬      
	if(csr & INSTSTL)                                           
	{                                   //STALL źŷ    
		usb_write_reg(INCSR1, INCLRDT); //лλ λ"0"
	}                                                           
	                                                            
	if(csr & INUNDRUN)                  //ݲ־ =1       
	{                                                           
		usb_write_reg(INCSR1, 0);       //IN״̬Ĵ  
	}
}
#endif

#ifdef EN_EP3IN
void usb_in_ep3(void)
{
BYTE csr;

	usb_write_reg(INDEX, 3);			//ѡ EP3              
	csr = usb_read_reg(INCSR1);         // IN ״̬      
	if(csr & INSTSTL)                                           
	{                                   //STALL źŷ    
		usb_write_reg(INCSR1, INCLRDT); //лλ λ"0"
	}                                                           
	                                                            
	if(csr & INUNDRUN)                  //ݲ־ =1       
	{                                                           
		usb_write_reg(INCSR1, 0);       //IN״̬Ĵ  
	}
}
#endif

#ifdef EN_EP4IN
void usb_in_ep4(void)
{
BYTE csr;

	usb_write_reg(INDEX, 4);			//ѡ EP4              
	csr = usb_read_reg(INCSR1);         // IN ״̬      
	if(csr & INSTSTL)                                           
	{                                   //STALL źŷ    
		usb_write_reg(INCSR1, INCLRDT); //лλ λ"0"
	}                                                           
	                                                            
	if(csr & INUNDRUN)                  //ݲ־ =1       
	{                                                           
		usb_write_reg(INCSR1, 0);       //IN״̬Ĵ  
	}
}
#endif

#ifdef EN_EP5IN
void usb_in_ep5(void)
{
BYTE csr;

	usb_write_reg(INDEX, 5);			//ѡ EP5              
	csr = usb_read_reg(INCSR1);         // IN ״̬      
	if(csr & INSTSTL)                                           
	{                                   //STALL źŷ    
		usb_write_reg(INCSR1, INCLRDT); //лλ λ"0"
	}                                                           
	                                                            
	if(csr & INUNDRUN)                  //ݲ־ =1       
	{                                                           
		usb_write_reg(INCSR1, 0);       //IN״̬Ĵ  
	}
}
#endif

#ifdef EN_EP1OUT
void usb_out_ep1(void)
{
BYTE csr;

	usb_write_reg(INDEX, 1);			//ѡ EP1
	csr = usb_read_reg(OUTCSR1);		// OUT ״̬
	if(csr & OUTSTSTL)
	{									//STALL źŷ
		usb_write_reg(OUTCSR1,OUTCLRDT);//лλ λ"0"
	}
	
	if(csr & OUTOPRDY)					//OUT ݽ
	{									//˵ݴ, INݷ
		usb_bulk_intr_in(UsbBuffer, usb_bulk_intr_out(UsbBuffer, 1), 1);    //ܲ,ԭ·
	}
}
#endif

#ifdef EN_EP2OUT
void usb_out_ep2(void)
{
BYTE csr;

	usb_write_reg(INDEX, 2);			//ѡ EP2              
	csr = usb_read_reg(OUTCSR1);        // OUT ״̬     
	if(csr & OUTSTSTL)                                         
	{                                   //STALL źŷ    
		usb_write_reg(OUTCSR1,OUTCLRDT);//лλ λ"0"
	}
	
	if(csr & OUTOPRDY)					//OUT ݽ
	{									//˵ݴ, OUTݽ
		usb_bulk_intr_out(Ep2OutBuffer, 2);
	}
}
#endif

#ifdef EN_EP3OUT
void usb_out_ep3(void)
{
BYTE csr;

	usb_write_reg(INDEX, 3);			//ѡ EP3              
	csr = usb_read_reg(OUTCSR1);        // OUT ״̬     
	if(csr & OUTSTSTL)                                         
	{                                   //STALL źŷ    
	    usb_write_reg(OUTCSR1,OUTCLRDT);//лλ λ"0"
	}
	
	if(csr & OUTOPRDY)					//OUT ݽ
	{									//˵ݴ, OUTݽ
	    usb_bulk_intr_out(Ep3OutBuffer, 3);
	}
}
#endif

#ifdef EN_EP4OUT
void usb_out_ep4(void)
{
BYTE csr;

	usb_write_reg(INDEX, 4);			//ѡ EP4              
	csr = usb_read_reg(OUTCSR1);        // OUT ״̬     
	if(csr & OUTSTSTL)                                         
	{                                   //STALL źŷ    
	    usb_write_reg(OUTCSR1,OUTCLRDT);//лλ λ"0"
	}
	
	if(csr & OUTOPRDY)					//OUT ݽ
	{									//˵ݴ, OUTݽ
	    usb_bulk_intr_out(Ep4OutBuffer, 4);
	}
}
#endif

#ifdef EN_EP5OUT
void usb_out_ep5(void)
{
BYTE csr;

	usb_write_reg(INDEX, 5);			//ѡ EP5              
	csr = usb_read_reg(OUTCSR1);        // OUT ״̬     
	if(csr & OUTSTSTL)                                          
	{                                   //STALL źŷ    
	    usb_write_reg(OUTCSR1,OUTCLRDT);//лλ λ"0"
	}
	
	if(csr & OUTOPRDY)					//OUT ݽ
	{									//˵ݴ, OUTݽ
	    usb_bulk_intr_out(Ep5OutBuffer, 5);
	}
}
#endif

//End Of File
