//======================================
//FileName	=	USB.h
//======================================

#ifndef __USB_H__
#define __USB_H__

//Ͷ
#define DESC_DEVICE             0x01	//豸
#define DESC_CONFIGURATION      0x02	//
#define DESC_STRING             0x03	//ַ
#define	DESC_INTERFACE			0x04	//ӿ
#define	DESC_ENDPOINT			0x05	//˵

//ݴ䷽
#define IN_DIRECT               0x80	//IN, 豸(1)
#define OUT_DIRECT              0x00	//OUT,豸(0)
#define DIRECT_MASK             0x80	//bmRequestType.bit7

//Ͷ
#define STANDARD_REQUEST        0x00	//׼(00)
#define CLASS_REQUEST           0x20	//(01)
#define VENDOR_REQUEST          0x40	//(10)
#define REQUEST_MASK            0x60	//bmRequestType.bit6:5	=11 

//(ݴĿ)Ͷ
#define DEVICE_RECIPIENT        0x00	//豸(0 0000)
#define INTERFACE_RECIPIENT     0x01	//ӿڽ(0 0001)
#define ENDPOINT_RECIPIENT      0x02	//˵(0 0010)
#define RECIPIENT_MASK          0x0f	//bmRequestType.bit3:0	bit4:0 =0 0011, =0 0100 ~ 1 1111

#define DEVICE_REMOTE_WAKEUP    0x01	//豸Զ̻
#define ENDPOINT_HALT           0x00	//ѾֹͣĶ˵

//˵ַ(bit7=1 IN, bit7=0 OUT, ˵=bit3:0)
#define EP1_IN                  0x81
#define EP1_OUT                 0x01
#define EP2_IN                  0x82
#define EP2_OUT                 0x02
#define EP3_IN                  0x83
#define EP3_OUT                 0x03
#define EP4_IN                  0x84
#define EP4_OUT                 0x04
#define EP5_IN                  0x85
#define EP5_OUT                 0x05

//豸״̬͵Ķ
#define DEVSTATE_ATTACHED       0		//
#define DEVSTATE_POWERED        1		//ϵ
#define DEVSTATE_DEFAULT        2		//Ĭ
#define DEVSTATE_ADDRESS        3		//ַ
#define DEVSTATE_CONFIGURED     4		//
#define DEVSTATE_SUSPENDED      5		//ѹ

//˵״̬͵Ķ
#define EPSTATE_IDLE            0		//
#define EPSTATE_HALT            1		//ֹͣ
#define EPSTATE_STATUS          2		//ȡ״̬
#define EPSTATE_DATAIN          3		//
#define EPSTATE_DATAOUT         4		//
#define EPSTATE_STALL           5		//ѽֹ()

//ñ(SETUP)ݽṹ
typedef struct
{
    BYTE    bmRequestType;				//
										//D7	ݴ䷽(0=豸, 1=豸)
										//D6:5	(0=׼,1=,2=,3=)
										//D4:0	(0=豸,1=ӿ,2=˵,3=,4~31=)
    BYTE    bRequest;					//
    BYTE    wValueL;					//ֵֽ
    BYTE    wValueH;					//ֵֽ
    BYTE    wIndexL;					//(ƫ)ֽ
    BYTE    wIndexH;					//(ƫ)ֽ
    WORD    wLength;					//DATA򳤶(ʵʳֵ,51ƬǸֽǰ),OUTеֽڴ˳ǡwLengthL wLengthH,Ҫ˳!
}SETUP;

//˵ݽṹ
typedef struct
{
    BYTE    bState;						//˵״̬
    WORD    wSize;						//˵㳤
    BYTE    *pData;						//˵
}EPSTATE;


//
void usb_init(void);
BYTE usb_read_reg(BYTE addr);
void usb_write_reg(BYTE addr, BYTE dat);
BYTE usb_read_fifo(BYTE fifo, BYTE *pdat);
void usb_write_fifo(BYTE fifo, BYTE *pdat, BYTE cnt);

void usb_setup_stall(void);
void usb_setup_in(void);
void usb_setup_out(void);
void usb_setup_status(void);

void usb_ctrl_in(void);
void usb_ctrl_out(void);
void usb_bulk_intr_in(BYTE *pData, BYTE bSize, BYTE ep);
BYTE usb_bulk_intr_out(BYTE *pData, BYTE ep);

void usb_resume(void);
void usb_reset(void);
void usb_suspend(void);
void usb_setup(void);
void usb_in_ep1(void);
void usb_in_ep2(void);
void usb_in_ep3(void);
void usb_in_ep4(void);
void usb_in_ep5(void);
void usb_out_ep1(void);
void usb_out_ep2(void);
void usb_out_ep3(void);
void usb_out_ep4(void);
void usb_out_ep5(void);


//
extern BYTE DeviceState;
extern SETUP Setup;
extern EPSTATE Ep0State;
extern BYTE InEpState;
extern BYTE OutEpState;

extern BYTE xdata UsbBuffer[256];

#endif

//End Of File
