//======================================
//FileName	=	usb_req_class.c
//USBļ
//======================================

#include "Ai8051U.h"
#include "usb.h"
#include "usb_req_class.h"

BYTE bHidIdle;							//HID ״ֽ̬


//USB
void usb_req_class(void)
{
	switch (Setup.bRequest)
	{
	case GET_REPORT:					//ȡ
		usb_get_report();
		break;
		
	case SET_REPORT:					//ñ
		usb_set_report();
		break;
		
	case GET_IDLE:						//ȡ״̬
		usb_get_idle();
		break;
		
	case SET_IDLE:						//ÿ
		usb_set_idle();
		break;
		
	case GET_PROTOCOL:					//ȡЭ
		usb_get_protocol();
		break;
		
	case SET_PROTOCOL:					//Э
		usb_set_protocol();
		break;
		
	default:
		usb_setup_stall();				//áֹ/ͣá
		return;
	}
}

//ȡ(豸->)
void usb_get_report(void)
{
	if( (DeviceState != DEVSTATE_CONFIGURED) ||
	    (Setup.bmRequestType != (IN_DIRECT | CLASS_REQUEST | INTERFACE_RECIPIENT)))
	{	//, IN||ǽӿ,   STALL ź
		usb_setup_stall();
		return;
	}
	
	Ep0State.pData = UsbBuffer;			//ָ
	Ep0State.wSize = Setup.wLength;		//ݳ
	usb_setup_in();						//ͱ浽
}

//ñ(->豸)
void usb_set_report(void)
{
	if ((DeviceState != DEVSTATE_CONFIGURED) ||
	    (Setup.bmRequestType != (OUT_DIRECT | CLASS_REQUEST | INTERFACE_RECIPIENT)))
	{	//, OUT||ǽӿ,   STALL ź
		usb_setup_stall();
		return;
	}
	
	Ep0State.pData = UsbBuffer;			//õ
	Ep0State.wSize = Setup.wLength;		//õݳ
	usb_setup_out();					//OUTĴ
}

//ȡ״̬(豸->)
void usb_get_idle(void)
{
    if ((DeviceState != DEVSTATE_CONFIGURED) ||
        (Setup.bmRequestType != (IN_DIRECT | CLASS_REQUEST | INTERFACE_RECIPIENT)))
    {	//, IN||ǽӿ,   STALL ź
        usb_setup_stall();
        return;
    }

    Ep0State.pData = &bHidIdle;			//õ״ֽ̬ڵĵַ
    Ep0State.wSize = 1;					//ݳ =1
    usb_setup_in();						//ͱĵ
}

//ÿ(->豸)
void usb_set_idle(void)
{
    if ((DeviceState != DEVSTATE_CONFIGURED) ||
        (Setup.bmRequestType != (OUT_DIRECT | CLASS_REQUEST | INTERFACE_RECIPIENT)))
    {	//, OUT||ǽӿ,   STALL ź
        usb_setup_stall();
        return;
    }

    bHidIdle = Setup.wValueH;			//HID״ֽ̬(ֻȡֽ)
    usb_setup_status();					//ö˵
}

//ȡЭ(豸->)
void usb_get_protocol(void)
{	// STALL ź,˵֧
    usb_setup_stall();
}

//Э(->豸)
void usb_set_protocol(void)
{	// STALL ź,˵֧
    usb_setup_stall();
}


//End Of File
