//======================================
//FileName	=	usb_req_std.c
//USB׼ļ
//ľϸڲμUSB2.0淶9!
//======================================

#include "Ai8051U.h"
#include "usb.h"
#include "usb_desc.h"
#include "usb_req_std.h"
#include "usb_req_class.h"

//--------------------------------------
//USB 豸˶ ׼ Ĵ
//[EP0  SETUP ĵӦ]
//--------------------------------------
void usb_req_std(void)
{
	switch (Setup.bRequest)
	{
	case GET_STATUS:
		usb_get_status();				//ȡ 豸/ӿ/˵ ״ֵ̬
		break;
		
	case CLEAR_FEATURE:
		usb_clear_feature();			// 豸/ӿ/˵ 
		break;
		
	case SET_FEATURE:
		usb_set_feature();				// 豸/ӿ/˵ 
		break;
		
	case SET_ADDRESS:
		usb_set_address();				//豸ͨŵַ, =0~127
		break;
	
	case GET_DESCRIPTOR:
		usb_get_descriptor();			//ȡ, ָ
		break;
	
	case SET_DESCRIPTOR:
		usb_set_descriptor();			//, 豸֧
		break;
	
	case GET_CONFIGURATION:
		usb_get_configuration();		//ȡ豸 ״ֵ̬, ݵbit0 =1 Ѿ, =0 û 
		break;
	
	case SET_CONFIGURATION:
		usb_set_configuration();		//豸 ֵ, =1 ,״̬, =0 ַ״̬ 
		break;
	
	case GET_INTERFACE:
		usb_get_interface();    		//ȡָӿڵѡеĿѡ
		break;
	
	case SET_INTERFACE:
		usb_set_interface();     		//ΪָĽӿѡһ
		break;
	
	case SYNCH_FRAME:
		usb_synch_frame();				//û㱨һͬ֡
		break;
	
	default:
		usb_setup_stall();				//Ĳ,򷵻 STALL ź
		return;
	}
}

//--------------------------------------
//ȡ 豸/ӿ/˵ ״ֵ̬
//ʹ InEpState, OutEpState
//--------------------------------------
void usb_get_status(void)
{
BYTE ep;								//˵, =1~5	AI8051U ƶ˵0,ֻOUT˵1~5  IN˵0x81~0x85

	if(((Setup.bmRequestType & DIRECT_MASK) != IN_DIRECT) ||	//bmRequestType.bit7 =1, [bmRequestType =0x80/0x81/0x82]
		(Setup.wValueH != 0) ||			//wValue =0x0000
		(Setup.wValueL != 0) ||
		(Setup.wLength != 2)			//wLength =2
	)
	{
		usb_setup_stall();				//Ĳ,򷵻 STALL ź
		return;
	}
	
	switch (Setup.bmRequestType & RECIPIENT_MASK)
	{									//bmRequestType.bit4:0 ָʾ˽, 0=豸, 1=ӿ, 2=˵, 3=;
	case DEVICE_RECIPIENT:				//ǻȡ豸״̬ 豸ǰ״̬޹,ֻҪȷ,ͿԷӦ!
		if( (Setup.wIndexH != 0) ||
			(Setup.wIndexL != 0)
		)
		{								//wIndex =0x0000
			usb_setup_stall();			//Ĳ,򷵻 STALL ź
			return;
		}
		else
		{								//=0x0000	[bit1=1 Զ̻ѹ,Ա SetFeature  ClearFeature ; bit1=0 ûԶ̻ѹ,ֹ!]
			Ep0State.pData = PACKET0;	//			[bit0=1 Թ豸,ܱ SetFeature  ClearFeature ; bit0=0 USB߹豸;]
			Ep0State.wSize = 2;			//ݳ =2
		}
		break;
	    
	case INTERFACE_RECIPIENT:			//ǻȡӿ״̬
		if( (DeviceState != DEVSTATE_CONFIGURED) ||		//豸óɹ,ܻȡӿ״̬
		    (Setup.wIndexH != 0) ||
		    (Setup.wIndexL != 0)		//wIndex =0x0000 豸ֻһӿ,ӿں =0x0000
		)
		{
		    usb_setup_stall();			//豸δóɹ || Ĳ,򷵻 STALL ź
		    return;
		}
		else
		{
		    Ep0State.pData = PACKET0;	//ӿ״̬ =0x0000
		    Ep0State.wSize = 2;			//ݳ =2
		}
		break;
		
	case ENDPOINT_RECIPIENT:			//ǻȡ˵״̬
		if( (DeviceState != DEVSTATE_CONFIGURED) ||		//豸óɹ,ܻȡ˵״̬
			(Setup.wIndexH != 0)		//wIndex =0x00NN  0xNNǶ˵
		)
		{
			usb_setup_stall();			//豸δóɹ || Ĳ,򷵻 STALL ź
			return;
		}
		else
		{
			ep = Setup.wIndexL & 0x0f;	//õ˵ =1~15
			
			switch (Setup.wIndexL)
			{
#ifdef EN_EP1IN
			case EP1_IN:
#endif
#ifdef EN_EP2IN
			case EP2_IN:
#endif
#ifdef EN_EP3IN
			case EP3_IN:
#endif
#ifdef EN_EP4IN
			case EP4_IN:
#endif
#ifdef EN_EP5IN
			case EP5_IN:
#endif
#if (defined(EN_EP1IN) || defined(EN_EP2IN) || defined(EN_EP3IN) || defined(EN_EP4IN) || defined(EN_EP5IN))
				if(InEpState & (1 << ep))
				{						//ָ˵״̬ =1,  0x0001 	˵״ֵ̬.bit0=1 ʾ˵ͣ HALT, =0 ʾ˵
					Ep0State.pData = PACKET1;
					Ep0State.wSize = 2;
				}
				else
				{						//ָ˵״̬ =0,  0x0000 	˵״ֵ̬.bit0=1 ʾ˵ͣ HALT, =0 ʾ˵
					Ep0State.pData = PACKET0;
					Ep0State.wSize = 2;
				}
				break;
#endif

#ifdef EN_EP1OUT
            case EP1_OUT:
#endif
#ifdef EN_EP2OUT
            case EP2_OUT:
#endif
#ifdef EN_EP3OUT
            case EP3_OUT:
#endif
#ifdef EN_EP4OUT
            case EP4_OUT:
#endif
#ifdef EN_EP5OUT
            case EP5_OUT:
#endif
#if (defined(EN_EP1OUT) || defined(EN_EP2OUT) || defined(EN_EP3OUT) || defined(EN_EP4OUT) || defined(EN_EP5OUT))
				if (OutEpState & (1 << ep))
				{						//ָ˵״̬ =1,  0x0001 	˵״ֵ̬.bit0=1 ʾ˵ͣ HALT, =0 ʾ˵
					Ep0State.pData = PACKET1;
					Ep0State.wSize = 2;
				}
				else
				{						//ָ˵״̬ =0,  0x0000 	˵״ֵ̬.bit0=1 ʾ˵ͣ HALT, =0 ʾ˵
					Ep0State.pData = PACKET0;
					Ep0State.wSize = 2;
				}
				break;
#endif

			default:
				usb_setup_stall();		//Ĳ,򷵻 STALL ź
				return;
			}
		}
		break;

	default:
		usb_setup_stall();				//Ľ߲,򷵻 STALL ź
		return;
	}
	
	usb_setup_in();						//USBӦ [з]
}


//--------------------------------------
// 豸/ӿ/˵ 
//豸֧Զ̻,ԳԶ˵Բ [ENDPOINT_HALT]
//--------------------------------------
void usb_clear_feature(void)
{
BYTE ep;								//˵, =1~5	AI8051U ƶ˵0,ֻOUT˵1~5  IN˵0x81~0x85
    
	if( (DeviceState != DEVSTATE_CONFIGURED) ||		//豸óɹ,
		(Setup.bmRequestType != (OUT_DIRECT | STANDARD_REQUEST | ENDPOINT_RECIPIENT)) ||	//bmRequestType =0x02 ˵Եı׼
		(Setup.wIndexH != 0) ||			//wIndex =0x00NN  0xNNǶ˵
		(Setup.wValueH != 0) ||			//wValue =0x00MM, 0xMM=ENDPOINT_HALT=0x00
		(Setup.wValueL != ENDPOINT_HALT) ||
		(Setup.wLength != 0)			//wLength =0x0000
	)
	{
		usb_setup_stall();				//豸δóɹ || Ĳ,򷵻 STALL ź
		return;
	}

	ep = Setup.wIndexL & 0x0f;			//õ˵ =1~15
	
	switch (Setup.wIndexL)
	{
#ifdef EN_EP1IN
	case EP1_IN:
#endif
#ifdef EN_EP2IN
	case EP2_IN:
#endif
#ifdef EN_EP3IN
	case EP3_IN:
#endif
#ifdef EN_EP4IN
	case EP4_IN:
#endif
#ifdef EN_EP5IN
	case EP5_IN:
#endif
#if (defined(EN_EP1IN) || defined(EN_EP2IN) || defined(EN_EP3IN) || defined(EN_EP4IN) || defined(EN_EP5IN))
		InEpState &= ~(1 << ep);		//ָ˵״̬ bit5~bit1 =0 ʾ˵0x85~0x81 ״̬
		usb_write_reg(INDEX, ep);		//ѡָ˵ =1~5
		usb_write_reg(INCSR1, INCLRDT);	//λINлλ =0 ˵㱻Ϊ
		usb_write_reg(INDEX, 0);		//ָ˵0
		break;
#endif

#ifdef EN_EP1OUT
	case EP1_OUT:
#endif
#ifdef EN_EP2OUT
	case EP2_OUT:
#endif
#ifdef EN_EP3OUT
    case EP3_OUT:
#endif
#ifdef EN_EP4OUT
	case EP4_OUT:
#endif
#ifdef EN_EP5OUT
	case EP5_OUT:
#endif
#if (defined(EN_EP1OUT) || defined(EN_EP2OUT) || defined(EN_EP3OUT) || defined(EN_EP4OUT) || defined(EN_EP5OUT))
		OutEpState &= ~(1 << ep);		//ָ˵״̬ bit5~bit1 =0 ʾ˵0x05~0x01 ״̬
		usb_write_reg(INDEX, ep);		//ѡָ˵ =1~5
		usb_write_reg(OUTCSR1,OUTCLRDT);//λOUTлλ =0 ˵㱻Ϊ
		usb_write_reg(INDEX, 0);		//ָ˵0
		break;
#endif

	default:
		usb_setup_stall();				//Ķ˵Ų,򷵻 STALL ź
		return;
	}

	usb_setup_status();					// OUT Ĵɵź [ûз]
}


//--------------------------------------
// 豸/ӿ/˵ 
//豸֧Զ̻,ԳԶ˵Բ [ENDPOINT_HALT]
//--------------------------------------
void usb_set_feature(void)
{
BYTE ep;								//˵, =1~5	AI8051U ƶ˵0,ֻOUT˵1~5  IN˵0x81~0x85

	if(	(DeviceState != DEVSTATE_CONFIGURED) ||		//豸óɹ,
		(Setup.bmRequestType != (OUT_DIRECT | STANDARD_REQUEST | ENDPOINT_RECIPIENT)) ||	//bmRequestType =0x02 ö˵Եı׼
		(Setup.wIndexH != 0) ||			//wIndex =0x00NN  0xNNǶ˵
		(Setup.wValueH != 0) ||			//wValue =0x00MM, 0xMM=ENDPOINT_HALT=0x00
		(Setup.wValueL != ENDPOINT_HALT) ||
		(Setup.wLength != 0))			//wLength =0x0000
	{
		usb_setup_stall();				//豸δóɹ || Ĳ,򷵻 STALL ź
		return;
	}
	
	ep = Setup.wIndexL & 0x0f;			//õ˵ =1~15
	switch (Setup.wIndexL)
	{
#ifdef EN_EP1IN
	case EP1_IN:
#endif
#ifdef EN_EP2IN
	case EP2_IN:
#endif
#ifdef EN_EP3IN
	case EP3_IN:
#endif
#ifdef EN_EP4IN
	case EP4_IN:
#endif
#ifdef EN_EP5IN
	case EP5_IN:
#endif
#if (defined(EN_EP1IN) || defined(EN_EP2IN) || defined(EN_EP3IN) || defined(EN_EP4IN) || defined(EN_EP5IN))
		InEpState |= (1 << ep);			//ָ˵״̬ bit5~bit1 =1 ʾ˵0x85~0x81 STALL״̬
		usb_write_reg(INDEX, ep);		//ѡָ˵ =1~5
		usb_write_reg(INCSR1, INSDSTL);	//IN˵STALLźŷ,ֹ˶˵㡾˵㱻ΪSTALL
		usb_write_reg(INDEX, 0);		//ָ˵0
		break;
#endif

#ifdef EN_EP1OUT
    case EP1_OUT:
#endif
#ifdef EN_EP2OUT
    case EP2_OUT:
#endif
#ifdef EN_EP3OUT
    case EP3_OUT:
#endif
#ifdef EN_EP4OUT
    case EP4_OUT:
#endif
#ifdef EN_EP5OUT
    case EP5_OUT:
#endif
#if (defined(EN_EP1OUT) || defined(EN_EP2OUT) || defined(EN_EP3OUT) || defined(EN_EP4OUT) || defined(EN_EP5OUT))
		OutEpState |= (1 << ep);		//ָ˵״̬ bit5~bit1 =1 ʾ˵0x05~0x01 STALL״̬
		usb_write_reg(INDEX, ep);       //ѡָ˵ =1~5
		usb_write_reg(OUTCSR1,OUTSDSTL);//OUT˵STALLźŷ,ֹ˶˵㡾˵㱻ΪSTALL
		usb_write_reg(INDEX, 0);		//ָ˵0
		break;
#endif
    
	default:
		usb_setup_stall();				//Ĳ,򷵻 STALL ź
		return;
	}

	usb_setup_status();					// OUT Ĵɵź [ûз]
}


//--------------------------------------
//豸ͨŵַ
//--------------------------------------
void usb_set_address(void)
{
BYTE addr;								//õĵֵַ, =0~127,

	if(	(Setup.bmRequestType != (OUT_DIRECT | STANDARD_REQUEST | DEVICE_RECIPIENT)) ||		//bmRequestType =0x00	0=OUT |00=׼ |=0 豸
		(Setup.wIndexH != 0) ||			//wIndex =0x0000
		(Setup.wIndexL != 0) ||
		(Setup.wValueH != 0) ||			//wValue =0x0000~0x007F	豸ַ
		(Setup.wValueL >= 0x80) ||
		(Setup.wLength != 0)			//wLength =0x0000
	)
	{
		usb_setup_stall();				//Ĳ,򷵻 STALL ź
		return;
	}
    
	addr = Setup.wValueL;				//ȡֵַ =0~127
	usb_write_reg(FADDR, addr);			//FADDR =USBַ
	if (addr != 0)
	{
		DeviceState = DEVSTATE_ADDRESS;	//ַ !=0, 豸ַ״̬
	}
	else
	{
		DeviceState = DEVSTATE_DEFAULT;	//ַ =0, 豸ȱʡ״̬
	}
	
	usb_setup_status();					// OUT Ĵɵź [ûз]
}


//--------------------------------------
//ȡ
//--------------------------------------
void usb_get_descriptor(void)
{
	if(	(Setup.bmRequestType & DIRECT_MASK) != IN_DIRECT)	//bmRequestType.bit7 =1, IN, [bmRequestType =0x80 IN |׼ | =豸]
	{
		usb_setup_stall();				//Ĳ,򷵻 STALL ź
		return;
	}
	
	switch(Setup.wValueH)				//  زͬ
	{									//wValueH =ʶ, wValueL = һֽڱʾ
	case DESC_DEVICE:					//豸
		Ep0State.pData = DEVICEDESC;
		Ep0State.wSize = sizeof(DEVICEDESC);
		break;
	
	case DESC_CONFIGURATION:			//
		Ep0State.pData = CONFIGDESC;
		Ep0State.wSize = sizeof(CONFIGDESC);
		break;
	
	case DESC_STRING:					//ַ
		switch (Setup.wValueL)
		{
		case 0:							//0 = ǹ̶ֵ
			Ep0State.pData = LANGIDDESC;
			Ep0State.wSize = sizeof(LANGIDDESC);
			break;
		
		case 1:							//1 =	iManufacturer(1);
			Ep0State.pData = MANUFACTDESC;
			Ep0State.wSize = sizeof(MANUFACTDESC);
			break;
		
		case 2:							//2 =Ʒ	iProduct(2);
			Ep0State.pData = PRODUCTDESC;
			Ep0State.wSize = sizeof(PRODUCTDESC);
			break;
		
		default:
			usb_setup_stall();			//Ĳ(ֵַ),򷵻 STALL ź
			return;
		}
		break;
		
	case DESC_HIDREPORT:				//HID
		Ep0State.pData = HIDREPORTDESC;
		Ep0State.wSize = sizeof(HIDREPORTDESC);
		break;
	
	default:
		usb_setup_stall();				//Ĳ(wValueH =),򷵻 STALL ź
		return;
	}
	
	if(Ep0State.wSize > Setup.wLength)	//ʵʷݵĳ Ϊ ƶ˵Ļ峤
	{
		Ep0State.wSize = Setup.wLength;
	}
	
	usb_setup_in();						//USBӦ [з]
}


//--------------------------------------
//豸
//豸ָ֧,򷵻һ
//--------------------------------------
void usb_set_descriptor(void)
{
    usb_setup_stall();					//Ĳ,򷵻 STALL ź
}


//-------------------------------------- 
//󷵻صǰ豸״̬
//ݰbit0: =1 豸Ѿ, =0 豸û
//--------------------------------------
void usb_get_configuration(void)
{
    if ((Setup.bmRequestType != (IN_DIRECT | STANDARD_REQUEST | DEVICE_RECIPIENT)) ||    //bmRequestType =0x80 IN | ׼ |  =豸
        (Setup.wValueH != 0) ||			//wValue =0x0000
        (Setup.wValueL != 0) ||
        (Setup.wIndexH != 0) ||			//wIndex =0x0000
        (Setup.wIndexL != 0) ||
        (Setup.wLength != 1)			//wLength =0x0001
    )
    {
        usb_setup_stall();				//Ĳ,򷵻 STALL ź
        return;
    }
    
    if (DeviceState == DEVSTATE_CONFIGURED)
    {
        Ep0State.pData = PACKET1;		// 0x0001 豸Ѿ
        Ep0State.wSize = 1;
    }
    else
    {
        Ep0State.pData = PACKET0;		// 0x0000 豸û
        Ep0State.wSize = 1;
    }

    usb_setup_in();						//USBӦ [з]
}


//--------------------------------------
//豸ֵ
//ú豸˵Ĳ(,,ݰ)
//--------------------------------------
void usb_set_configuration(void)
{
	if(	(DeviceState == DEVSTATE_DEFAULT) ||	//ȱʡ״̬ 豸ֵ, 豸Ӧ޶
		(Setup.bmRequestType != (OUT_DIRECT | STANDARD_REQUEST | DEVICE_RECIPIENT)) ||	//bmRequestType =0x00 [OUT | ׼ | =豸]
		(Setup.wValueH != 0) ||			//wValue =0x00NN	0xNN ֵ
		(Setup.wIndexH != 0) ||			//wIndex =0x0000
		(Setup.wIndexL != 0) ||
		(Setup.wLength != 0)			//wLength =0x0000
	)
	{
		usb_setup_stall();				//Ĳ,򷵻 STALL ź
		return;
	}

	if(Setup.wValueL == 1)
	{									//ֵ =0x0001	豸 bConfigurationValue(1) ֵһ! 
		DeviceState = DEVSTATE_CONFIGURED;	//豸״̬ =Ѿ
		InEpState = 0x00;				//IN˵Ϊ IDEL
		OutEpState = 0x00;				//OUT˵Ϊ IDEL
#ifdef EN_EP1IN
		usb_write_reg(INDEX, 1);		//ѡEP1
		usb_write_reg(INCSR2, INMODEIN);//AUTOSET=0 ֹԶ IPRDY, ISO=0 ˵Ϊ/жϴ䷽ʽ, MODE=1 0x81ΪIN, FCDT=0 ˵DATA0/DATA1л ڷݰ׵ACKʱл; 
		usb_write_reg(INMAXP, EP1IN_SIZE / 8);	//EP1INݰ,λ=8ֽ
#endif
#ifdef EN_EP2IN
		usb_write_reg(INDEX, 2);		//ѡEP2
		usb_write_reg(INCSR2, INMODEIN);//AUTOSET=0 ֹԶ IPRDY, ISO=0 ˵Ϊ/жϴ䷽ʽ, MODE=1 0x81ΪIN, FCDT=0 ˵DATA0/DATA1л ڷݰ׵ACKʱл; 
		usb_write_reg(INMAXP, EP2IN_SIZE / 8);	//EP2INݰ,λ=8ֽ
#endif
#ifdef EN_EP3IN
		usb_write_reg(INDEX, 3);		//ѡEP3
		usb_write_reg(INCSR2, INMODEIN);//AUTOSET=0 ֹԶ IPRDY, ISO=0 ˵Ϊ/жϴ䷽ʽ, MODE=1 0x81ΪIN, FCDT=0 ˵DATA0/DATA1л ڷݰ׵ACKʱл; 
		usb_write_reg(INMAXP, EP3IN_SIZE / 8);	//EP3INݰ,λ=8ֽ
#endif
#ifdef EN_EP4IN
		usb_write_reg(INDEX, 4);		//ѡEP4
		usb_write_reg(INCSR2, INMODEIN);//AUTOSET=0 ֹԶ IPRDY, ISO=0 ˵Ϊ/жϴ䷽ʽ, MODE=1 0x81ΪIN, FCDT=0 ˵DATA0/DATA1л ڷݰ׵ACKʱл; 
		usb_write_reg(INMAXP, EP4IN_SIZE / 8);	//EP4INݰ,λ=8ֽ
#endif
#ifdef EN_EP5IN
		usb_write_reg(INDEX, 5);		//ѡEP5
		usb_write_reg(INCSR2, INMODEIN);//AUTOSET=0 ֹԶ IPRDY, ISO=0 ˵Ϊ/жϴ䷽ʽ, MODE=1 0x81ΪIN, FCDT=0 ˵DATA0/DATA1л ڷݰ׵ACKʱл; 
		usb_write_reg(INMAXP, EP5IN_SIZE / 8);	//EP5INݰ,λ=8ֽ
#endif


#ifdef EN_EP1OUT
		usb_write_reg(INDEX, 1);		//ѡEP1
		usb_write_reg(INCSR2,INMODEOUT);//AUTOSET=0 ֹԶ IPRDY, ISO=0 ˵Ϊ/жϴ䷽ʽ, MODE=0 0x01ΪOUT, FCDT=0 ˵DATA0/DATA1л ڷݰ׵ACKʱл; 
		usb_write_reg(OUTMAXP, EP1OUT_SIZE /8);	//EP1OUTݰ,λ=8ֽ	
#endif
#ifdef EN_EP2OUT
		usb_write_reg(INDEX, 2);		//ѡEP2
		usb_write_reg(INCSR2,INMODEOUT);//AUTOSET=0 ֹԶ IPRDY, ISO=0 ˵Ϊ/жϴ䷽ʽ, MODE=0 0x02ΪOUT, FCDT=0 ˵DATA0/DATA1л ڷݰ׵ACKʱл; 
		usb_write_reg(OUTMAXP, EP2OUT_SIZE /8);	//EP2OUTݰ,λ=8ֽ
#endif
#ifdef EN_EP3OUT
		usb_write_reg(INDEX, 3);		//ѡEP3
		usb_write_reg(INCSR2,INMODEOUT);//AUTOSET=0 ֹԶ IPRDY, ISO=0 ˵Ϊ/жϴ䷽ʽ, MODE=0 0x03ΪOUT, FCDT=0 ˵DATA0/DATA1л ڷݰ׵ACKʱл; 
		usb_write_reg(OUTMAXP, EP3OUT_SIZE /8);	//EP3OUTݰ,λ=8ֽ
#endif
#ifdef EN_EP4OUT
		usb_write_reg(INDEX, 4);		//ѡEP4
		usb_write_reg(INCSR2,INMODEOUT);//AUTOSET=0 ֹԶ IPRDY, ISO=0 ˵Ϊ/жϴ䷽ʽ, MODE=0 0x04ΪOUT, FCDT=0 ˵DATA0/DATA1л ڷݰ׵ACKʱл; 
		usb_write_reg(OUTMAXP, EP4OUT_SIZE /8);	//EP4OUTݰ,λ=8ֽ
#endif
#ifdef EN_EP5OUT
		usb_write_reg(INDEX, 5);		//ѡEP5
		usb_write_reg(INCSR2,INMODEOUT);//AUTOSET=0 ֹԶ IPRDY, ISO=0 ˵Ϊ/жϴ䷽ʽ, MODE=0 0x05ΪOUT, FCDT=0 ˵DATA0/DATA1л ڷݰ׵ACKʱл; 
		usb_write_reg(OUTMAXP, EP5OUT_SIZE /8);	//EP5OUTݰ,λ=8ֽ
#endif

		usb_write_reg(INDEX, 0);		//ѡEP0
	}
	else
	{									//ֵ !=0x0001
		DeviceState = DEVSTATE_ADDRESS;	//豸״̬ = ַ
		InEpState = 0xff;				//IN˵ =STALL
		OutEpState = 0xff;				//OUT˵ =STALL
	}

	usb_setup_status();					// OUT Ĵɵź [ûз]
}


//--------------------------------------
//ȡָӿڵѡеĿѡ
//--------------------------------------
void usb_get_interface(void)
{
	if(	(DeviceState != DEVSTATE_CONFIGURED) ||		//豸óɹ,ܻȡ ӿ
		(Setup.bmRequestType != (IN_DIRECT | STANDARD_REQUEST | INTERFACE_RECIPIENT)) ||	//bmRequestType =0x81	1=IN |00=׼ |=1 ӿڡ
		(Setup.wValueH != 0) ||			//wValue =0x0000
		(Setup.wValueL != 0) ||
		(Setup.wIndexH != 0) ||			//wIndex =0x00NN	0xNN ǽӿں
		(Setup.wLength != 1)			//wLength =0x0001	
	)
	{
		usb_setup_stall();				//Ĳ,򷵻 STALL ź
		return;
	}
	
	Ep0State.pData = PACKET0;			// =0x0000, ͽӿ bAlternateSetting(0) ֵһ!
	Ep0State.wSize = 1;
	
	usb_setup_in();						//USBӦ [з]
}


//--------------------------------------
//ΪָĽӿѡһ
//--------------------------------------
void usb_set_interface(void)
{
	if(	(DeviceState != DEVSTATE_CONFIGURED) ||		//豸óɹ,ָܽӿڵ
		(Setup.bmRequestType != (OUT_DIRECT | STANDARD_REQUEST | INTERFACE_RECIPIENT)) ||	//bmRequestType =0x01	0=OUT |00=׼ |=1 ӿڡ
		(Setup.wValueH != 0) ||			//wValue =0x00NN	0xNNǿѡ
		(Setup.wIndexH != 0) ||			//wIndex =0x00MM	0xMMǽӿں 	
		(Setup.wLength != 0)			//wLength =0x0000
	)
    {
        usb_setup_stall();				//Ĳ,򷵻 STALL ź
        return;
    }

    usb_setup_status();					// OUT Ĵɵź [ûз]
}


//--------------------------------------
//û㱨һͬ֡
//--------------------------------------
void usb_synch_frame(void)
{
    usb_setup_stall();					//豸û֧ͬĶ˵,򷵻 STALL ź
}

//End Of File
